class ReadSourceFile:
    def __init__(self, _filename):
        # Init variables
        self.path = _filename
        self.filename = self.path.split("/")[-1]
        self.module_name = self.filename.replace(".f90", "")
        self.lines = []
        self.text = ""

        # Read file
        self.read_file(_filename)

    def read_file(self, _filename):
        try:
            with open(_filename) as f:
                self.text = f.read()
                self.lines = self.text.split("\n")
        except UnicodeDecodeError:
            with open(_filename, encoding="latin1") as f:
                self.text = f.read()
                self.lines = self.text.split("\n")

    def rebuild_text(self):
        self.text = "".join([l + "\n" for l in self.lines[:] if l.strip()])

    def save_modified_file(self, file_path=None):
        if file_path:
            path = file_path + "/" + self.filename
        else:
            path = self.path
        with open(path, "w") as output_file:
            output_file.write(self.text)
